=== debian/changelog ===
supertux (0.4.0-1ubuntu1) xenial; urgency=medium

  * Fix appstream metadata so that SuperTux shows in the Software app.
    (LP: #1560550)

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sun, 30 Oct 2016 20:26:27 -0400

supertux (0.4.0-1) unstable; urgency=medium

  * New upstream release.
    - Remove all patches; applied upstream or obsolete.
  * Remove debian/menu file as per tech-ctte decision in #741573.
  * Update Homepage field in d/control.
  * Update debian/watch to point to correct upstream tarball.

 -- Vincent Cheng <vcheng@debian.org>  Mon, 21 Dec 2015 14:54:44 -0800

supertux (0.3.5a-2) unstable; urgency=medium

  * Fix FTBFS on big-endian archs. Thanks to Fabian Greffrath for the patch!
    (Closes: #787698)
  * Install high resolution icon. (Closes: #794358)

 -- Vincent Cheng <vcheng@debian.org>  Thu, 20 Aug 2015 01:07:00 -0700
