=== debian/watch ===
version=3
https://github.com/SuperTux/supertux/releases .*/releases/download/.*/supertux-(\d.*)\.(?:tgz|tbz2|tar\.(?:gz|bz2|xz))
