=== debian/changelog ===
supertux (0.5.0-1build1) zesty; urgency=high

  * No change rebuild against boost1.62.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 01 Nov 2016 16:49:18 +0000

supertux (0.5.0-1) unstable; urgency=medium

  * New upstream release.
    - Add build-dep on libboost-{date-time,filesystem,system}-dev.
  * Fix appstream metadata. (LP: #1560550)
  * Bump standards version to 3.9.8.
  * Update watch file.

 -- Vincent Cheng <vcheng@debian.org>  Sun, 25 Sep 2016 20:03:17 -0700
