=== debian/control ===
--- 
+++ 
@@ -11,7 +11,10 @@
  autotools-dev,
  cmake (>= 2.6),
  debhelper (>= 9),
- libboost-dev,
+ libboost-date-time-dev (>= 1.41),
+ libboost-dev (>= 1.41),
+ libboost-filesystem-dev (>= 1.41),
+ libboost-system-dev (>= 1.41),
  libcurl4-gnutls-dev,
  libglew-dev,
  libopenal-dev,
@@ -20,9 +23,9 @@
  libsdl2-image-dev (>= 2.0.0),
  libvorbis-dev,
  pkg-config
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Vcs-Svn: svn://anonscm.debian.org/pkg-games/packages/trunk/supertux/
-Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-games/packages/trunk/supertux/
+Vcs-Browser: https://anonscm.debian.org/viewvc/pkg-games/packages/trunk/supertux/
 Homepage: http://supertuxproject.org/
 
 Package: supertux
